/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import com.rjconsultores.ventaboletos.entidad.Categoria;
import com.rjconsultores.ventaboletos.service.CategoriaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextbox;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import java.util.Calendar;
import java.util.List;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Rafius
 */
@Controller("editarCategoriaController")
@Scope("prototype")
public class EditarCategoriaController extends MyGenericForwardComposer {

    @Autowired
    private CategoriaService categoriaService;
    private Categoria categoria;
    private MyListbox categoriaList;
    private Button btnApagar;
    private static Logger log = Logger.getLogger(EditarCategoriaController.class);
    private MyTextbox txtNome;

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        categoria = (Categoria) Executions.getCurrent().getArg().get("categoria");
        categoriaList = (MyListbox) Executions.getCurrent().getArg().get("categoriaList");

        if (categoria.getCategoriaId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        } else {
            if (categoria.getCategoriaId() == 1) {
                btnApagar.setVisible(Boolean.FALSE);
                txtNome.setDisabled(Boolean.TRUE);

                Messagebox.show(
                        Labels.getLabel("MSG.noEditabled"),
                        Labels.getLabel("editarCategoriaController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            }
        }

        txtNome.focus();
    }

    public void onClick$btnSalvar(Event ev) throws InterruptedException {
        txtNome.getValue();
        try {
            categoria.setActivo(true);
            categoria.setFecmodif(Calendar.getInstance().getTime());
            categoria.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());

            if (categoria.getCategoriaId() != null) {
                List<Categoria> lsCategoria = categoriaService.buscar(categoria.getDesccategoria());
                if (!lsCategoria.isEmpty()) {
                    Messagebox.show(
                            Labels.getLabel("MSG.Registro.Existe"),
                            Labels.getLabel("editarCategoriaController.window.title"),
                            Messagebox.OK, Messagebox.EXCLAMATION);
                    return;
                }
            }

            if (categoria.getCategoriaId() == null) {
                List<Categoria> lsCategoria =
                        categoriaService.buscar(categoria.getDesccategoria().trim());

                if (lsCategoria.isEmpty()) {
                    categoriaService.suscribir(categoria);
                    categoriaList.addItem(categoria);

                    Messagebox.show(
                            Labels.getLabel("editarCategoriaController.MSG.suscribirOK"),
                            Labels.getLabel("editarCategoriaController.window.title"),
                            Messagebox.OK, Messagebox.INFORMATION);
                } else {
                    Messagebox.show(
                            Labels.getLabel("MSG.Registro.Existe"),
                            Labels.getLabel("editarCategoriaController.window.title"),
                            Messagebox.OK, Messagebox.EXCLAMATION);
                }
            } else {
                categoriaService.actualizacion(categoria);
                categoriaList.updateItem(categoria);

                Messagebox.show(
                        Labels.getLabel("editarCategoriaController.MSG.suscribirOK"),
                        Labels.getLabel("editarCategoriaController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            }

            closeWindow();
        } catch (Exception ex) {
            log.error("editarCategoriaController: " + ex);
            Messagebox.show(
                    Labels.getLabel("MSG.Error"),
                    Labels.getLabel("editarCategoriaController.window.title"),
                    Messagebox.OK, Messagebox.ERROR);
        }
    }

    public void onClick$btnApagar(Event ev) {
        try {
            int resp = Messagebox.show(
                    Labels.getLabel("editarCategoriaController.MSG.borrarPergunta"),
                    Labels.getLabel("editarCategoriaController.window.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp == Messagebox.YES) {

                categoriaService.borrar(categoria);

                Messagebox.show(
                        Labels.getLabel("editarCategoriaController.MSG.borrarOK"),
                        Labels.getLabel("editarCategoriaController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                categoriaList.removeItem(categoria);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }

    public Categoria getCategoria() {
        return categoria;
    }

    public void setCategoria(Categoria categoria) {
        this.categoria = categoria;
    }

    public MyListbox getCategoriaList() {
        return categoriaList;
    }

    public void setCategoriaList(MyListbox categoriaList) {
        this.categoriaList = categoriaList;
    }

    public CategoriaService getCategoriaService() {
        return categoriaService;
    }

    public void setCategoriaService(CategoriaService categoriaService) {
        this.categoriaService = categoriaService;
    }
}
