/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.esquemaoperacional;

import com.rjconsultores.ventaboletos.entidad.Autobus;
import com.rjconsultores.ventaboletos.entidad.Corrida;
import com.rjconsultores.ventaboletos.entidad.DiagramaAutobus;
import com.rjconsultores.ventaboletos.service.AutobusService;
import com.rjconsultores.ventaboletos.service.CorridaService;
import com.rjconsultores.ventaboletos.service.DiagramaAutobusService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import java.util.Calendar;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Administrador
 */
@Controller("editarAutobusController")
@Scope("prototype")
public class EditarAutobusController extends MyGenericForwardComposer {

    @Autowired
    private AutobusService autobusService;
    @Autowired
    private DiagramaAutobusService diagramaAutobusService;
    @Autowired
    private CorridaService corridaService;
    private List<DiagramaAutobus> lsDiagramaAutobus;
    private Autobus autobus;
    private MyListbox autobusList;
    private Textbox txtNome;
    private Combobox cmbDiagramaAutobus;
    private Combobox cmbDiagramaAutobusPiso;
    private Button btnApagar;
    private static Logger log = Logger.getLogger(EditarAutobusController.class);

    public Autobus getAutobus() {
        return autobus;
    }

    public void setAutobus(Autobus autobus) {
        this.autobus = autobus;
    }

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    public List<DiagramaAutobus> getLsDiagramaAutobus() {
        return lsDiagramaAutobus;
    }

    public void setLsDiagramaAutobus(List<DiagramaAutobus> lsDiagramaAutobus) {
        this.lsDiagramaAutobus = lsDiagramaAutobus;
    }

    public Textbox getTxtNome() {
        return txtNome;
    }

    public void setTxtNome(Textbox txtNome) {
        this.txtNome = txtNome;
    }

    public Combobox getCmbDiagramaAutobus() {
        return cmbDiagramaAutobus;
    }

    public void setCmbDiagramaAutobus(Combobox cmbDiagramaAutobus) {
        this.cmbDiagramaAutobus = cmbDiagramaAutobus;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        lsDiagramaAutobus = diagramaAutobusService.obtenerTodos();
        super.doAfterCompose(comp);

        autobus = (Autobus) Executions.getCurrent().getArg().get("autobus");
        autobusList = (MyListbox) Executions.getCurrent().getArg().get("autobusList");

        txtNome.focus();

        if (autobus.getAutobusId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        }
    }

    public void onClick$btnSalvar(Event ev) throws InterruptedException {
        txtNome.getValue();
        cmbDiagramaAutobus.getSelectedItem();

        try {
            autobus.setActivo(Boolean.TRUE);
            autobus.setFecmodif(Calendar.getInstance().getTime());
            autobus.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());

            List<Autobus> lsAutobus =
                    autobusService.buscar(autobus.getNumautobus(),
                    autobus.getDiagramaAutobus());

            boolean podeSalvar = false;
            if (lsAutobus.isEmpty()) {
                podeSalvar = true;
            } else {
                if (autobus.getAutobusId() != null) {
                    for (Autobus c : lsAutobus) {
                        if (c.getAutobusId().equals(autobus.getAutobusId())) {
                            podeSalvar = true;
                        }
                    }
                }
            }
            if (!podeSalvar) {

                Messagebox.show(
                        Labels.getLabel("MSG.Registro.Existe"),
                        Labels.getLabel("editarAutobusController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
            } else {
                if (autobus.getAutobusId() == null) {
                    autobusService.suscribir(autobus);
                    autobusList.addItem(autobus);
                } else {
                    autobusService.actualizacion(autobus);
                    autobusList.updateItem(autobus);
                }

                Messagebox.show(
                        Labels.getLabel("editarAutobusController.MSG.suscribirOK"),
                        Labels.getLabel("editarAutobusController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error("editarAutobusController: " + ex);
            Messagebox.show(
                    Labels.getLabel("MSG.Error"),
                    Labels.getLabel("editarAutobusController.window.title"),
                    Messagebox.OK, Messagebox.ERROR);
        }
    }

    public void onClick$btnApagar(Event ev) {
        try {
            int resp = Messagebox.show(
                    Labels.getLabel("editarAutobusController.MSG.borrarPergunta"),
                    Labels.getLabel("editarAutobusController.window.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp == Messagebox.YES) {

                if ((corridaService.buscarPorAutobusCorridasFuturas(autobus.getDiagramaAutobus()).isEmpty()) && 
                		(corridaService.buscarPorRolOperativoCorridasFuturas(autobus.getDiagramaAutobus()).isEmpty())) {

                    autobusService.borrar(autobus);

                    Messagebox.show(
                            Labels.getLabel("editarAutobusController.MSG.borrarOK"),
                            Labels.getLabel("editarAutobusController.window.title"),
                            Messagebox.OK, Messagebox.INFORMATION);

                    autobusList.removeItem(autobus);

                    closeWindow();
                } else {
                    Messagebox.show(
                            Labels.getLabel("editarDiagramaAutobusController.MSG.Corrida.Futura"),
                            Labels.getLabel("editarDiagramaAutobusController.window.title"),
                            Messagebox.OK, Messagebox.EXCLAMATION);
                }
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }
}
