/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.esquemaoperacional;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.WrongValueException;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.util.Clients;
import org.zkoss.zul.Button;
import org.zkoss.zul.Checkbox;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Intbox;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Spinner;
import org.zkoss.zul.Tab;
import org.zkoss.zul.Textbox;
import org.zkoss.zul.Timebox;

import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.entidad.Tramo;
import com.rjconsultores.ventaboletos.entidad.TramoKm;
import com.rjconsultores.ventaboletos.entidad.TramoServicio;
import com.rjconsultores.ventaboletos.entidad.TramoTiempo;
import com.rjconsultores.ventaboletos.entidad.Via;
import com.rjconsultores.ventaboletos.service.ClaseServicioService;
import com.rjconsultores.ventaboletos.service.EmpresaService;
import com.rjconsultores.ventaboletos.service.EsquemaCorridaService;
import com.rjconsultores.ventaboletos.service.ParadaService;
import com.rjconsultores.ventaboletos.service.RutaCombinacionService;
import com.rjconsultores.ventaboletos.service.TramoService;
import com.rjconsultores.ventaboletos.service.ViaService;
import com.rjconsultores.ventaboletos.utilerias.ApplicationProperties;
import com.rjconsultores.ventaboletos.utilerias.DateUtil;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.ConstraintNumberBD;
import com.rjconsultores.ventaboletos.web.utilerias.MyComboboxParada;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderTramoKm;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderTramoServicio;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderTramoTiempo;

/**
 * 
 * @author Administrador
 */
@Controller("editarTramosController")
@Scope("prototype")
public class EditarTramosController extends MyGenericForwardComposer {

    @Autowired
    private TramoService tramoService;
    @Autowired
    private ParadaService paradaService;
    @Autowired
    private ViaService viaService;
    @Autowired
    private EmpresaService empresaService;
    @Autowired
    private ClaseServicioService claseServicioService;
    @Autowired
    private EsquemaCorridaService esquemaCorridaService;
    @Autowired
    private RutaCombinacionService rutaCombinacionService;
    private List<Via> lsVias;
    private List<ClaseServicio> lsClaseServicio;
    private Tramo tramo;
    private MyListbox tramosList;
    private MyListbox tiempoList;
    private MyListbox tramoKmEmpresaList;
    private List<TramoServicio> listaTramoServicio;
    private List<TramoTiempo> listaTramosTiempo;
    private List<TramoKm> listaTramosKm;
    private MyListbox servicioList;
    private MyComboboxParada cmbParadaOrigem;
    private MyComboboxParada cmbParadaDestino;
    private Combobox cmbClaseServicio;
    private Combobox cmbVia;
    private Combobox cmbEmpresa;
    private Textbox txKmReal;
    private Textbox txtKmPagoConductor;
    private Textbox txtNome;
    private Intbox itxCantkmpagoconductor;
    private Combobox cmbClaseServicioTiempo;
    private Timebox horainicio;
    private Timebox horafin;
    private Intbox txtnumdiasemana;
    private Checkbox lun;
    private Checkbox mar;
    private Checkbox mie;
    private Checkbox jue;
    private Checkbox vie;
    private Checkbox sab;
    private Checkbox dom;
    private Spinner spHora;
    private Spinner spMinuto;
    private Spinner spHoraTiempo;
    private Spinner spMinutoTiempo;
    private Button btnApagar;
    private ConstraintNumberBD constraintTarifa;
    private List<Empresa> lsEmpresa;
    private Tab tabExcepcionesKm;
    private static Logger log = Logger.getLogger(EditarTramosController.class);

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        lsVias = viaService.obtenerTodos();
        lsEmpresa = empresaService.obtenerTodos();
        lsClaseServicio = claseServicioService.buscarTodosExceto(-1);

        super.doAfterCompose(comp);

        servicioList.setItemRenderer(new RenderTramoServicio());
        tiempoList.setItemRenderer(new RenderTramoTiempo());
        tramoKmEmpresaList.setItemRenderer(new RenderTramoKm());

        listaTramoServicio = new ArrayList<TramoServicio>();
        listaTramosTiempo = new ArrayList<TramoTiempo>();
        listaTramosKm = new ArrayList<TramoKm>();

        tramo = (Tramo) Executions.getCurrent().getArg().get("tramo");
        if (tramo.getTramoId() != null) {
            tramo = tramoService.obtenerID(tramo.getTramoId());

            for (TramoServicio ta : tramo.getTramoServicioList()) {
                listaTramoServicio.add(ta);
            }
            servicioList.setData(listaTramoServicio);

            for (TramoTiempo tt : tramo.getLsTramoTiempo()) {
                listaTramosTiempo.add(tt);
            }
            tiempoList.setData(listaTramosTiempo);

            for (TramoKm tk : tramo.getTramoKms()) {
                listaTramosKm.add(tk);
            }
            tramoKmEmpresaList.setData(listaTramosKm);
        }
        tramosList = (MyListbox) Executions.getCurrent().getArg().get("tramosList");

        if (tramo.getTramoId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        }

        txtNome.focus();

        constraintTarifa = new ConstraintNumberBD(8, 2, true);

        txKmReal.setConstraint(constraintTarifa);
        txtKmPagoConductor.setConstraint(constraintTarifa);
        tabExcepcionesKm.setVisible(ApplicationProperties.getInstance().exhibirExcepcionesTramoKm());

        aplicarMascaras();
    }

    private void aplicarMascaras() {
        Clients.evalJavaScript("jQuery('#" + txKmReal.getUuid() + "').format({allow_negative:false,precision: 2,decimal:'.',autofix:true});");
        Clients.evalJavaScript("jQuery('#" + txtKmPagoConductor.getUuid() + "').format({allow_negative:false,precision: 2,decimal:'.',autofix:true});");
    }

    public void onClick$btnSalvarServicio(Event ev) throws InterruptedException {
        spHora.getValue();
        spMinuto.getValue();

        if (cmbClaseServicio.getSelectedItem() == null) {
            Messagebox.show(Labels.getLabel("editarTramosController.MSG.tipoServicio"), Labels.getLabel("editarTramosController.window.title"), Messagebox.OK,
                    Messagebox.EXCLAMATION);
            return;
        }

        try {

            ClaseServicio claseServicio = (ClaseServicio) cmbClaseServicio.getSelectedItem().getValue();

            boolean existe = false;
            for (TramoServicio tt : listaTramoServicio) {
                if (tt.getClaseServicio().equals(claseServicio)) {
                    existe = true;
                }
            }

            if (!existe) {
                TramoServicio ts = new TramoServicio();
                ts.setClaseServicio((ClaseServicio) cmbClaseServicio.getSelectedItem().getValue());
                ts.setTiemporecorrido(DateUtil.getFecInicio(spHora.getValue(), spMinuto.getValue()).getTime());
                ts.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
                ts.setFecmodif(Calendar.getInstance().getTime());
                ts.setActivo(Boolean.TRUE);

                listaTramoServicio.add(ts);
                servicioList.setData(listaTramoServicio);

                cmbClaseServicio.setSelectedItem(null);

                spHora.setText("00");
                spMinuto.setText("00");

            } else {
                Messagebox.show(Labels.getLabel("MSG.Registro.Existe"), Labels.getLabel("editarTramosController.window.title"), Messagebox.OK, Messagebox.EXCLAMATION);
            }
        } catch (WrongValueException ex) {
            throw (WrongValueException) ex;
        } catch (Exception ex) {
            log.error(ex);
            Messagebox.show(Labels.getLabel("MSG.Error"), Labels.getLabel("editarTramosController.window.title"), Messagebox.OK, Messagebox.ERROR);
        }
    }

    public void onClick$btnSalvarTiempo(Event ev) throws InterruptedException {
        spHoraTiempo.getValue();
        spMinutoTiempo.getValue();

        if (!lun.isChecked() && !mar.isChecked() && !mie.isChecked() && !jue.isChecked() && !vie.isChecked() && !sab.isChecked() && !dom.isChecked()) {

            Messagebox.show(Labels.getLabel("editarTramosController.MSG.obligatorioTramoTiempoDia"), Labels.getLabel("editarTramosController.window.title"), Messagebox.OK,
                    Messagebox.INFORMATION);

            return;
        }
        try {
            ClaseServicio claseServicio = (ClaseServicio) cmbClaseServicioTiempo.getSelectedItem().getValue();

            boolean existe = false;
            for (TramoTiempo tt : listaTramosTiempo) {
                if (tt.getClaseServicio().equals(claseServicio)) {
                    existe = true;
                }
            }

            if (!existe) {

                TramoTiempo tramoTiempo = new TramoTiempo();
                tramoTiempo.setClaseServicio(claseServicio);

                tramoTiempo.setHorafin(DateUtil.getFecInicio(horafin.getValue()).getTime());
                tramoTiempo.setHorainicio(DateUtil.getFecInicio(horainicio.getValue()).getTime());
                tramoTiempo.setIndapliclun(lun.isChecked());
                tramoTiempo.setIndaplicmar(mar.isChecked());
                tramoTiempo.setIndaplicmie(mie.isChecked());
                tramoTiempo.setIndaplicjue(jue.isChecked());
                tramoTiempo.setIndaplicvie(vie.isChecked());
                tramoTiempo.setIndaplicsab(sab.isChecked());
                tramoTiempo.setIndaplicdom(dom.isChecked());
                tramoTiempo.setTiemporecorrido(DateUtil.getFecInicio(spHoraTiempo.getValue(), spMinutoTiempo.getValue()).getTime());

                tramoTiempo.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
                tramoTiempo.setFecmodif(Calendar.getInstance().getTime());
                tramoTiempo.setActivo(Boolean.TRUE);

                listaTramosTiempo.add(tramoTiempo);
                tiempoList.setData(listaTramosTiempo);

                spHoraTiempo.setText("00");
                spMinutoTiempo.setText("00");
            } else {
                Messagebox.show(Labels.getLabel("MSG.Registro.Existe"), Labels.getLabel("editarTramosController.window.title"), Messagebox.OK, Messagebox.EXCLAMATION);
            }
        } catch (WrongValueException ex) {
            throw (WrongValueException) ex;
        } catch (Exception ex) {
            log.error(ex);
            Messagebox.show(Labels.getLabel("MSG.Error"), Labels.getLabel("editarTramosController.window.title"), Messagebox.OK, Messagebox.ERROR);
        }
    }

    public void onClick$btnSalvarExceptioneKm(Event ev) throws InterruptedException {
        itxCantkmpagoconductor.getValue();
        cmbEmpresa.getValue();

        Empresa empresa = (Empresa) cmbEmpresa.getSelectedItem().getValue();

        boolean existe = false;
        for (TramoKm tk : listaTramosKm) {
            if (tk.getEmpresa().equals(empresa)) {
                existe = true;
            }
        }

        if (!existe) {
            TramoKm tramoKm = new TramoKm();
            tramoKm.setEmpresa(empresa);
            tramoKm.setCantkmpagoconductor(itxCantkmpagoconductor.getValue());

            tramoKm.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
            tramoKm.setFecmodif(Calendar.getInstance().getTime());
            tramoKm.setActivo(Boolean.TRUE);

            listaTramosKm.add(tramoKm);
            tramoKmEmpresaList.setData(listaTramosKm);

        } else {
            Messagebox.show(Labels.getLabel("MSG.Registro.Existe"), Labels.getLabel("editarTramosController.window.title"), Messagebox.OK, Messagebox.EXCLAMATION);
        }

    }

    public void onClick$btnApagarServicio(Event ev) throws InterruptedException {
        try {
            TramoServicio tramoAtributo = (TramoServicio) servicioList.getSelected();

            if (tramoAtributo != null) {
                int opcao = Messagebox.show(Labels.getLabel("editarTramosController.MSG.borrarTramoServicio"), Labels.getLabel("editarTramosController.window.title"),
                        Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

                if (opcao == Messagebox.YES) {
                    tramoAtributo.setFecmodif(Calendar.getInstance().getTime());
                    tramoAtributo.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
                    tramoAtributo.setActivo(Boolean.FALSE);

                    listaTramoServicio.remove(tramoAtributo);
                    servicioList.setData(listaTramoServicio);
                }
            } else {
                Messagebox.show(Labels.getLabel("editarTramosController.MSG.selecioneTramoServicio"), Labels.getLabel("editarTramosController.window.title"), Messagebox.OK,
                        Messagebox.EXCLAMATION);
            }
        } catch (WrongValueException ex) {
            throw (WrongValueException) ex;
        } catch (Exception ex) {
            log.error(ex);
            Messagebox.show(Labels.getLabel("MSG.Error"), Labels.getLabel("editarTramosController.window.title"), Messagebox.OK, Messagebox.ERROR);
        }
    }

    public void onClick$btnApagarTiempo(Event ev) throws InterruptedException {
        try {
            TramoTiempo tramoTiempo = (TramoTiempo) tiempoList.getSelected();

            if (tramoTiempo != null) {
                int opcao = Messagebox.show(Labels.getLabel("editarTramosController.MSG.borrarTramoTiempo"), Labels.getLabel("editarTramosController.window.title"), Messagebox.YES
                        | Messagebox.NO, Messagebox.QUESTION);

                if (opcao == Messagebox.YES) {
                    tramoTiempo.setFecmodif(Calendar.getInstance().getTime());
                    tramoTiempo.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
                    tramoTiempo.setActivo(Boolean.FALSE);

                    listaTramosTiempo.remove(tramoTiempo);
                    tiempoList.setData(listaTramosTiempo);
                }
            } else {
                Messagebox.show(Labels.getLabel("editarTramosController.MSG.selecioneTramoTiempo"), Labels.getLabel("editarTramosController.window.title"), Messagebox.OK,
                        Messagebox.EXCLAMATION);
            }
        } catch (WrongValueException ex) {
            throw (WrongValueException) ex;
        } catch (Exception ex) {
            log.error(ex);
            Messagebox.show(Labels.getLabel("MSG.Error"), Labels.getLabel("editarTramosController.window.title"), Messagebox.OK, Messagebox.ERROR);
        }
    }

    public void onClick$btnApagarExcepcioneKm(Event ev) throws InterruptedException {

        TramoKm tramoKm = (TramoKm) tramoKmEmpresaList.getSelected();

        if (tramoKm != null) {
            int opcao = Messagebox.show(Labels.getLabel("editarTramosController.MSG.borrarTramoKm"), Labels.getLabel("editarTramosController.window.title"), Messagebox.YES
                    | Messagebox.NO, Messagebox.QUESTION);

            if (opcao == Messagebox.YES) {
                tramoKm.setFecmodif(Calendar.getInstance().getTime());
                tramoKm.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
                tramoKm.setActivo(Boolean.FALSE);

                listaTramosKm.remove(tramoKm);
                tramoKmEmpresaList.setData(listaTramosKm);
            }
        } else {
            Messagebox.show(Labels.getLabel("editarTramosController.MSG.selecioneTramoKm"), Labels.getLabel("editarTramosController.window.title"), Messagebox.OK,
                    Messagebox.EXCLAMATION);
        }

    }

    public void onClick$btnSalvar(Event ev) throws InterruptedException {
        txKmReal.getValue();
        txtKmPagoConductor.getValue();
        txtNome.getValue();
        cmbParadaOrigem.getValue(true);
        cmbParadaDestino.getValue(true);

        if (listaTramoServicio.isEmpty()) {
            Messagebox.show(Labels.getLabel("editarTramosController.MSG.obligatorioTramoTiempo"), Labels.getLabel("editarTramosController.window.title"), Messagebox.OK,
                    Messagebox.INFORMATION);

            return;
        }

        try {
            tramo.setActivo(Boolean.TRUE);
            tramo.setFecmodif(Calendar.getInstance().getTime());
            tramo.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());

            Parada origem = tramo.getOrigem();
            Parada destino = tramo.getDestino();

            tramo.setVia((Via) cmbVia.getSelectedItem().getValue());
            tramo.setLsTramoTiempo(listaTramosTiempo);
            tramo.setTramoServicioList(listaTramoServicio);
            tramo.setTramoKms(listaTramosKm);

            if (!origem.getParadaId().equals(destino.getParadaId())) {
                Tramo tramoConsulta = tramoService.buscar(tramo.getOrigem(), tramo.getDestino(), tramo.getVia());

                boolean podeSalvar = false;
                if (tramoConsulta == null) {
                    podeSalvar = true;
                } else {
                    if (tramoConsulta.getTramoId().equals(tramo.getTramoId())) {
                        podeSalvar = true;
                    }
                }
                if (podeSalvar) {
                    if (tramo.getTramoId() == null) {

                        tramoService.suscribir(tramo);
                        tramosList.addItem(tramo);

                        Messagebox.show(Labels.getLabel("editarTramosController.MSG.suscribirOK"), Labels.getLabel("editarTramosController.window.title"), Messagebox.OK,
                                Messagebox.INFORMATION);

                        closeWindow();

                    } else {
                        tramoService.actualizacion(tramo);
                        tramosList.updateItem(tramo);

                        Messagebox.show(Labels.getLabel("editarTramosController.MSG.suscribirOK"), Labels.getLabel("editarTramosController.window.title"), Messagebox.OK,
                                Messagebox.INFORMATION);

                        closeWindow();
                    }
                } else {
                    Messagebox.show(Labels.getLabel("MSG.Registro.Existe.Origem.Destino.Via"), Labels.getLabel("editarTramosController.window.title"), Messagebox.OK,
                            Messagebox.EXCLAMATION);
                }
            } else {
                Messagebox.show(Labels.getLabel("editarTramosController.MSG.OrigemDestinoIguais"), Labels.getLabel("editarTramosController.window.title"), Messagebox.OK,
                        Messagebox.EXCLAMATION);
            }
        } catch (Exception ex) {

            if (ex instanceof WrongValueException) {
                throw (WrongValueException) ex;
            }

            log.error(ex);
            Messagebox.show(Labels.getLabel("MSG.Error"), Labels.getLabel("editarTramosController.window.title"), Messagebox.OK, Messagebox.ERROR);
        }
    }

    public void onClick$btnApagar(Event ev) throws InterruptedException {
        try {
            int resp = Messagebox.show(Labels.getLabel("editarTramosController.MSG.borrarPergunta"), Labels.getLabel("editarTramosController.window.title"), Messagebox.YES
                    | Messagebox.NO, Messagebox.QUESTION);

            if (resp == Messagebox.YES) {
                boolean existeCombinacion = rutaCombinacionService.buscarRutaCombinacionExisteTramo(tramo);
                boolean existeEsquemaCorrida = esquemaCorridaService.buscarEsquemaCorridaExisteTramo(tramo);
                if (existeCombinacion == false && existeEsquemaCorrida == false) {
                    tramoService.borrar(tramo);

                    Messagebox.show(Labels.getLabel("editarTramosController.MSG.borrarOK"), Labels.getLabel("editarTramosController.window.title"), Messagebox.OK,
                            Messagebox.INFORMATION);

                    tramosList.removeItem(tramo);

                    closeWindow();
                } else {
                    Messagebox.show(Labels.getLabel("editarTramosController.MSG.borrarFalse"), Labels.getLabel("editarTramosController.window.title"), Messagebox.OK,
                            Messagebox.EXCLAMATION);

                }

            }
        } catch (WrongValueException ex) {
            throw (WrongValueException) ex;
        } catch (Exception ex) {
            log.error(ex);
            Messagebox.show(Labels.getLabel("MSG.Error"), Labels.getLabel("editarTramosController.window.title"), Messagebox.OK, Messagebox.ERROR);
        }
    }

    public Intbox getTxtnumdiasemana() {
        return txtnumdiasemana;
    }

    public void setTxtnumdiasemana(Intbox txtnumdiasemana) {
        this.txtnumdiasemana = txtnumdiasemana;
    }

    public MyListbox getTiempoList() {
        return tiempoList;
    }

    public void setTiempoList(MyListbox tiempoList) {
        this.tiempoList = tiempoList;
    }

    public Tramo getTramo() {
        return tramo;
    }

    public Combobox getCmbClaseServicioTiempo() {
        return cmbClaseServicioTiempo;
    }

    public void setCmbClaseServicioTiempo(Combobox cmbClaseServicioTiempo) {
        this.cmbClaseServicioTiempo = cmbClaseServicioTiempo;
    }

    public void setTramo(Tramo tramo) {
        this.tramo = tramo;
    }

    public List<Via> getLsVias() {
        return lsVias;
    }

    public void setLsVias(List<Via> lsVias) {
        this.lsVias = lsVias;
    }

    public MyListbox getAtributoList() {
        return servicioList;
    }

    public void setAtributoList(MyListbox atributoList) {
        this.servicioList = atributoList;
    }

    public Combobox getCmbClaseServicio() {
        return cmbClaseServicio;
    }

    public void setCmbClaseServicio(Combobox cmbClaseServicio) {
        this.cmbClaseServicio = cmbClaseServicio;
    }

    public List<ClaseServicio> getLsClaseServicio() {
        return lsClaseServicio;
    }

    public void setLsClaseServicio(List<ClaseServicio> lsClaseServicio) {
        this.lsClaseServicio = lsClaseServicio;
    }

    public Textbox getTxtNome() {
        return txtNome;
    }

    public void setTxtNome(Textbox txtNome) {
        this.txtNome = txtNome;
    }

    public Timebox getHorafin() {
        return horafin;
    }

    public void setHorafin(Timebox horafin) {
        this.horafin = horafin;
    }

    public Timebox getHorainicio() {
        return horainicio;
    }

    public void setHorainicio(Timebox horainicio) {
        this.horainicio = horainicio;
    }

    public Checkbox getDom() {
        return dom;
    }

    public void setDom(Checkbox dom) {
        this.dom = dom;
    }

    public Checkbox getLun() {
        return lun;
    }

    public void setLun(Checkbox lun) {
        this.lun = lun;
    }

    public Checkbox getMar() {
        return mar;
    }

    public void setMar(Checkbox mar) {
        this.mar = mar;
    }

    public Checkbox getMie() {
        return mie;
    }

    public void setMie(Checkbox mie) {
        this.mie = mie;
    }

    public Checkbox getSab() {
        return sab;
    }

    public void setSab(Checkbox sab) {
        this.sab = sab;
    }

    public Checkbox getVie() {
        return vie;
    }

    public void setVie(Checkbox vie) {
        this.vie = vie;
    }

    public List<Empresa> getLsEmpresa() {
        return lsEmpresa;
    }
}
