/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.pricing;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Datebox;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.Pricing;
import com.rjconsultores.ventaboletos.service.EmpresaService;
import com.rjconsultores.ventaboletos.service.PricingService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderPricing;

/**
 * 
 * @author Rafius
 */
@Controller("busquedaPricingController")
@Scope("prototype")
public class BusquedaPricingController extends MyGenericForwardComposer {

	@Autowired
	private transient PagedListWrapper<Pricing> plwPricingPunto;
	@Autowired
	private PricingService pricingService;
	@Autowired
	private EmpresaService empresaService;
	private MyListbox pricingList;
	private Paging pagingPricing;
	private List<Pricing> lsPricing;
	private List<Empresa> lsEmpresa;
	private Combobox cmbEmpresa;
	private Textbox txtNome;
	private Datebox fechaInicio;
	private Datebox fechaFin;
	private static Logger log = Logger
			.getLogger(BusquedaPricingController.class);

	@Override
	public void doAfterCompose(Component comp) throws Exception {

		lsEmpresa = empresaService.obtenerIndTipo1();

		super.doAfterCompose(comp);

		pricingList.setItemRenderer(new RenderPricing());
		pricingList.addEventListener("onDoubleClick", new EventListener() {

			@Override
			public void onEvent(Event event) throws Exception {
				Pricing pricing = (Pricing) pricingList.getSelected();
				verPricing(pricing);
			}
		});

		lsPricing = new ArrayList<Pricing>();

		refreshLista();
	}

	public void onClick$btnPesquisa(Event ev) throws InterruptedException {
		refreshLista();
	}

	public void onClick$btnRefresh(Event ev) {
		refreshLista();
	}

	public void onClick$btnNovo(Event ev) {
		verPricing(new Pricing());
	}

	private void refreshLista() {
		Empresa empresa = (Empresa) (cmbEmpresa.getSelectedItem() != null ? cmbEmpresa
				.getSelectedItem().getValue() : null);

		HibernateSearchObject<Pricing> pricingSearch = new HibernateSearchObject<Pricing>(
				Pricing.class, pagingPricing.getPageSize());

		if (empresa != null) {
			pricingSearch.addFilterEqual("empresa", empresa);
		}

		if (!txtNome.getValue().isEmpty()) {
			pricingSearch.addFilterILike("nombPricing", txtNome.getValue()
					+ "%");
		}

		if (fechaInicio.getValue() != null) {
			pricingSearch.addFilterGreaterOrEqual(
					"pricingVigenciaList.fecinicioviaje", fechaInicio.getValue());
		}
		if (fechaFin.getValue() != null) {
			pricingSearch.addFilterLessOrEqual(
					"pricingVigenciaList.fecfinviaje", fechaFin.getValue());
		}

		pricingSearch.addFilterEqual("activo", Boolean.TRUE);

		pricingSearch.addSortAsc("nombPricing");

		plwPricingPunto.init(pricingSearch, pricingList, pagingPricing);

		if (pricingList.getData().length == 0) {
			try {
				Messagebox.show(Labels.getLabel("MSG.ningunRegistro"), Labels
						.getLabel("busquedaPricingController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			} catch (InterruptedException ex) {
			}
		}
	}

	private void verPricing(Pricing pricing) {
		if (pricing == null) {
			return;
		}

		Map args = new HashMap();
		args.put("pricing", pricing);
		args.put("gravarNovo", pricing.getPricingId() == null);
		args.put("pricingList", pricingList);

		openWindow("/gui/pricing/editarPricing.zul",
				Labels.getLabel("editarPricingController.window.title"), args,
				MODAL);
	}

	public void onClick$btnApagar(Event ev) {
		try {
			Pricing p = (Pricing) pricingList.getSelected();
			if (p != null) {
				int resp = Messagebox
						.show(Labels
								.getLabel("editarPricingController.MSG.borrarPergunta"),
								Labels.getLabel("busquedaPricingController.window.title"),
								Messagebox.YES | Messagebox.NO,
								Messagebox.QUESTION);

				if (resp == Messagebox.YES) {
					pricingService.borrar(p);
					Messagebox
							.show(Labels
									.getLabel("editarPricingController.MSG.borrarOK"),
									Labels.getLabel("busquedaPricingController.window.title"),
									Messagebox.OK, Messagebox.INFORMATION);
					pricingList.removeItem(p);
				}
			} else {
				Messagebox
						.show(Labels
								.getLabel("editarPricingController.MSG.selectItem"),
								Labels.getLabel("busquedaPricingController.window.title"),
								Messagebox.OK, Messagebox.EXCLAMATION);
			}
		} catch (Exception ex) {
			log.error("Erro ao eliminar Pricing: " + ex);
		}
	}

	public List<Pricing> getLsPricing() {
		return lsPricing;
	}

	public void setLsPricing(List<Pricing> lsPricing) {
		this.lsPricing = lsPricing;
	}

	public Paging getPagingPricing() {
		return pagingPricing;
	}

	public void setPagingPricing(Paging pagingPricing) {
		this.pagingPricing = pagingPricing;
	}

	public PagedListWrapper<Pricing> getPlwPricingPunto() {
		return plwPricingPunto;
	}

	public void setPlwPricingPunto(PagedListWrapper<Pricing> plwPricingPunto) {
		this.plwPricingPunto = plwPricingPunto;
	}

	public MyListbox getPricingList() {
		return pricingList;
	}

	public void setPricingList(MyListbox pricingList) {
		this.pricingList = pricingList;
	}

	public PricingService getPricingService() {
		return pricingService;
	}

	public void setPricingService(PricingService pricingService) {
		this.pricingService = pricingService;
	}

	public EmpresaService getEmpresaService() {
		return empresaService;
	}

	public void setEmpresaService(EmpresaService empresaService) {
		this.empresaService = empresaService;
	}

	public List<Empresa> getLsEmpresa() {
		return lsEmpresa;
	}

	public void setLsEmpresa(List<Empresa> lsEmpresa) {
		this.lsEmpresa = lsEmpresa;
	}

	public Textbox getTxtNome() {
		return txtNome;
	}

	public void setTxtNome(Textbox txtNome) {
		this.txtNome = txtNome;
	}

	public Datebox getFechaInicio() {
		return fechaInicio;
	}

	public void setFechaInicio(Datebox fechaInicio) {
		this.fechaInicio = fechaInicio;
	}

	public Datebox getFechaFin() {
		return fechaFin;
	}

	public void setFechaFin(Datebox fechaFin) {
		this.fechaFin = fechaFin;
	}
	
	
}
