/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.seguridad;

import com.rjconsultores.ventaboletos.entidad.Perfil;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderPerfil;
import java.util.HashMap;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

/**
 *
 * @author rodrigo
 */
@Controller("busquedaPerfilController")
@Scope("prototype")
public class BusquedaPerfilController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<Perfil> plwPerfil;
    private MyListbox perfilList;
    private Paging pagingPerfil;
    private Textbox txtNome;

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        perfilList.setItemRenderer(new RenderPerfil());
        perfilList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                Perfil s = (Perfil) perfilList.getSelected();
                verSistema(s);
            }
        });

        refreshLista();

        txtNome.focus();
    }

    private void verSistema(Perfil s) {
        if (s == null) {
            return;
        }

        Map args = new HashMap();
        args.put("perfil", s);
        args.put("perfilList", perfilList);

        openWindow("/gui/seguridad/editarPerfil.zul",
                Labels.getLabel("editarPerfilController.window.title"), args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<Perfil> sistemaBusqueda =
                new HibernateSearchObject<Perfil>(Perfil.class,
                pagingPerfil.getPageSize());

        String descPerfil = txtNome.getText();
        if (descPerfil != null) {
            sistemaBusqueda.addFilterLike("descperfil", "%" + descPerfil.trim().concat("%"));
        }

        sistemaBusqueda.addSortAsc("descperfil");
        sistemaBusqueda.addFilterEqual("activo", Boolean.TRUE);

        plwPerfil.init(sistemaBusqueda, perfilList, pagingPerfil);

        if (perfilList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaPerfilController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }

    public void onClick$btnPesquisa(Event ev) {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verSistema(new Perfil());
    }
}
