/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.seguridad;

import com.rjconsultores.ventaboletos.entidad.Estacion;
import com.rjconsultores.ventaboletos.entidad.PuntoVenta;
import com.rjconsultores.ventaboletos.entidad.UsuarioBancario;
import com.rjconsultores.ventaboletos.exception.BusinessException;
import com.rjconsultores.ventaboletos.service.EstacionService;
import com.rjconsultores.ventaboletos.service.UsuarioBancarioService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyComboboxPuntoVenta;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.util.Clients;
import org.zkoss.zul.Button;
import org.zkoss.zul.Checkbox;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Label;
import org.zkoss.zul.Longbox;
import org.zkoss.zul.Textbox;

/**
 * 
 * @author Administrador
 */
@Controller("editarEstacionController")
@Scope("prototype")
public class EditarEstacionController extends MyGenericForwardComposer {

    @Autowired
    private EstacionService estacionService;
    @Autowired
    private UsuarioBancarioService usuarioBancarioService;
    private MyListbox estacionList;
    private Button btnApagar;
    private Textbox txtDescEstacion;
    private Textbox txtDescMac;
    private Longbox txtNumCaja;
    private Estacion estacion;
    private List<PuntoVenta> lsPuntoVenta;
    private List<UsuarioBancario> lsUsuarioBancario;
    private MyComboboxPuntoVenta cmbPuntoVenta;
    private Combobox cmbConexion;
    private Checkbox chkPinPad;
    private Label lbPinPad;
    private static Logger log = Logger.getLogger(EditarEstacionController.class);

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    public Estacion getEstacion() {
        return estacion;
    }

    public void setEstacion(Estacion estacion) {
        this.estacion = estacion;
    }

    public Textbox getTxtDescEstacion() {
        return txtDescEstacion;
    }

    public void setTxtDescEstacion(Textbox txtDescEstacion) {
        this.txtDescEstacion = txtDescEstacion;
    }

    public List<PuntoVenta> getLsPuntoVenta() {
        return lsPuntoVenta;
    }

    public void setLsPuntoVenta(List<PuntoVenta> lsPuntoVenta) {
        this.lsPuntoVenta = lsPuntoVenta;
    }

    public Textbox getTxtDescMac() {
        return txtDescMac;
    }

    public void setTxtDescMac(Textbox txtDescMac) {
        this.txtDescMac = txtDescMac;
    }

    public Longbox getTxtNumCaja() {
        return txtNumCaja;
    }

    public void setTxtNumCaja(Longbox txtNumCaja) {
        this.txtNumCaja = txtNumCaja;
    }

    public List<UsuarioBancario> getLsUsuarioBancario() {
        return lsUsuarioBancario;
    }

    public void setLsUsuarioBancario(List<UsuarioBancario> lsUsuarioBancario) {
        this.lsUsuarioBancario = lsUsuarioBancario;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        lsUsuarioBancario = usuarioBancarioService.obtenerTodos();
        lsPuntoVenta = new ArrayList<PuntoVenta>();

        estacion = (Estacion) Executions.getCurrent().getArg().get("estacion");
        estacionList = (MyListbox) Executions.getCurrent().getArg().get("estacionList");

        lbPinPad.setVisible(Boolean.FALSE);
        chkPinPad.setVisible(Boolean.FALSE);

        if (estacion.getEstacionId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        } else {
            // Convertendo a mascara em Hexa novamente.
            if (estacion.getDescmac() != null && !estacion.getDescmac().equals("")) {
                Long hx = Long.parseLong(estacion.getDescmac(), 10);
                String descMac = Long.toHexString(hx);
                while (descMac.length() < 12) {
                    descMac = "0" + descMac;
                }
                // AABBCCDDEEFF
                // AA-BB-CC-DD-EE-FF
                descMac = descMac.substring(0, 2).concat("-").concat(descMac.substring(2, 4).concat("-")).concat(descMac.substring(4, 6)).concat("-").concat(descMac.substring(6, 8)).concat("-").concat(descMac.substring(8, 10).concat("-")).concat(descMac.substring(10, 12));

                txtDescMac.setText(descMac.toUpperCase());
            }

            if (estacion.getConexionBancaria() != null) {
                if (estacion.getConexionBancaria().equals("S")) {
                    lbPinPad.setVisible(Boolean.TRUE);
                    chkPinPad.setVisible(Boolean.TRUE);

                    if (estacion.getPinPadImpresoraPropia() != null) {
                        chkPinPad.setChecked(estacion.getPinPadImpresoraPropia());
                    }
                }
            }
        }

        txtDescEstacion.focus();

    }

    public void onClick$btnSalvar(Event ev) throws InterruptedException {

        cmbPuntoVenta.getValue(true);
        cmbConexion.getValue();

        if (cmbConexion.getValue().equals("")) {
            estacion.setConexionBancaria(null);
            estacion.setUsuarioBancario(null);
        }

        String descMac = txtDescMac.getText();

        estacion.setActivo(Boolean.TRUE);
        estacion.setFecmodif(Calendar.getInstance().getTime());
        estacion.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        estacion.setDescmac(estacionService.getDecimalMAC(descMac).toString());
        estacion.setPinPadImpresoraPropia(chkPinPad.isChecked());

        try {
            estacionService.suscribirActualizar(estacion);
            Messagebox.show(Labels.getLabel("editarEstacionController.MSG.suscribirOK"),
                    Labels.getLabel("editarEstacionController.window.title"), Messagebox.OK, Messagebox.INFORMATION);

            closeWindow();

        } catch (BusinessException e) {
            Messagebox.show(e.getMessage(), Labels.getLabel("editarEstacionController.window.title"), Messagebox.OK, Messagebox.EXCLAMATION);
        }
    }

    public void onClick$btnApagar(Event ev) {
        try {
            int resp = Messagebox.show(Labels.getLabel("editarEstacionController.MSG.borrarPergunta"),
                    Labels.getLabel("editarEstacionController.window.title"), Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp == Messagebox.YES) {
                estacionService.borrar(estacion);

                Messagebox.show(Labels.getLabel("editarEstacionController.MSG.borrarOK"),
                        Labels.getLabel("editarEstacionController.window.title"), Messagebox.OK, Messagebox.INFORMATION);

                estacionList.removeItem(estacion);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error(ex);
            Clients.alert(Labels.getLabel("MSG.Error"), Labels.getLabel("editarEstacionController.window.title"), Messagebox.INFORMATION);
        }
    }

    public void onChange$cmbConexion(Event ev) {
        habilitarCombo();
        if (cmbConexion.getValue().equals("")) {
            estacion.setConexionBancaria(null);
            estacion.setUsuarioBancario(null);
        }
    }

    private void habilitarCombo() {
        Comboitem cbi = cmbConexion.getSelectedItem();
        if (cbi != null) {
            String valor = (String) cbi.getValue();

            if (valor.equals("S")) {
                lbPinPad.setVisible(Boolean.TRUE);
                chkPinPad.setVisible(Boolean.TRUE);
            } else {
                lbPinPad.setVisible(Boolean.FALSE);
                chkPinPad.setVisible(Boolean.FALSE);
                chkPinPad.setChecked(Boolean.FALSE);
            }
        }
    }
}
