/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.tarifas;

import com.rjconsultores.ventaboletos.entidad.Tarifa;
import com.rjconsultores.ventaboletos.entidad.VigenciaTarifa;
import com.rjconsultores.ventaboletos.service.TarifaService;
import com.rjconsultores.ventaboletos.service.VigenciaTarifaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import java.util.Calendar;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Datebox;

/**
 *
 * @author rodrigo
 */
@Controller("editarVigenciaTarifaController")
@Scope("prototype")
public class EditarVigenciaTarifaController extends MyGenericForwardComposer {

    @Autowired
    private VigenciaTarifaService vigenciaTarifaService;
    @Autowired
    private TarifaService tarifaService;
    private VigenciaTarifa vigenciaTarifa;
    private MyListbox vigenciaList;
    private Button btnApagar;
    private Datebox fecInicio;
    private Datebox fecFinal;
    private Datebox fecVenta;
    private Logger log = Logger.getLogger(EditarVigenciaTarifaController.class);

    public MyListbox getVigenciaList() {
        return vigenciaList;
    }

    public void setVigenciaList(MyListbox vigenciaList) {
        this.vigenciaList = vigenciaList;
    }

    public VigenciaTarifa getVigenciaTarifa() {
        return vigenciaTarifa;
    }

    public void setVigenciaTarifa(VigenciaTarifa vigenciaTarifa) {
        this.vigenciaTarifa = vigenciaTarifa;
    }

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    public Datebox getFecInicio() {
        return fecInicio;
    }

    public void setFecInicio(Datebox fecInicio) {
        this.fecInicio = fecInicio;
    }

    public Datebox getFecFinal() {
        return fecFinal;
    }

    public void setFecFinal(Datebox fecFinal) {
        this.fecFinal = fecFinal;
    }

    public Datebox getFecVenta() {
        return fecVenta;
    }

    public void setFecVenta(Datebox fecVenta) {
        this.fecVenta = fecVenta;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        vigenciaTarifa = (VigenciaTarifa) Executions.getCurrent().getArg().get("vigenciaTarifa");
        vigenciaList = (MyListbox) Executions.getCurrent().getArg().get("vigenciaList");

        if (vigenciaTarifa.getVigenciatarifaId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        }

        fecInicio.focus();
    }

    public void onClick$btnSalvar(Event ev) {
        fecInicio.getValue();
        fecFinal.getValue();
        //fecVenta.getValue();
        try {
            java.util.Date inicio = vigenciaTarifa.getFeciniciovigencia();
            java.util.Date fim = vigenciaTarifa.getFecfinvigencia();

            inicio.setSeconds(0);
            fim.setSeconds(0);
            
            List<VigenciaTarifa> lsVT1 =
                    vigenciaTarifaService.buscarVigenciasIntervalo(vigenciaTarifa);

            // checando se o fim da vigencia eh menor que o inicio:
            if (!fim.before(inicio)) {
                // checando se a vigencia pode ser salva. A data de inicio de uma
                // nova vigencia tem q ser maior que a da fim da vigencia anterior
                // para que não tenha tarifas com duas vigencias:

                Boolean podeSalvar = lsVT1.isEmpty() ? true : false;
                //Se for ele mesmo pode salvar.
                if (lsVT1.size() == 1) {
                    //Somente edição
                    if (vigenciaTarifa.getVigenciatarifaId() != null) {
                        if (vigenciaTarifa.getVigenciatarifaId().equals(lsVT1.get(0).getVigenciatarifaId())) {
                            podeSalvar = true;
                        }
                    }
                }

                if (podeSalvar) {
                        if (vigenciaTarifa.getVigenciatarifaId() == null) {
                            if (lsVT1.isEmpty()) {
                                vigenciaTarifaService.suscribir(vigenciaTarifa);
                                vigenciaList.addItem(vigenciaTarifa);

                                Messagebox.show(
                                        Labels.getLabel("editarVigenciaTarifaController.btnFechar.MSG.SuscbrirOK"),
                                        Labels.getLabel("editarVigenciaTarifaController.window.title"),
                                        Messagebox.OK, Messagebox.INFORMATION);

                                closeWindow();
                            } else {
                                Messagebox.show(
                                        Labels.getLabel("MSG.Registro.Existe"),
                                        Labels.getLabel("editarVigenciaTarifaController.window.title"),
                                        Messagebox.OK, Messagebox.EXCLAMATION);
                            }
                        } else {
                            vigenciaTarifaService.actualizacion(vigenciaTarifa);
                            vigenciaList.updateItem(vigenciaTarifa);

                            Messagebox.show(
                                    Labels.getLabel("editarVigenciaTarifaController.btnFechar.MSG.SuscbrirOK"),
                                    Labels.getLabel("editarVigenciaTarifaController.window.title"),
                                    Messagebox.OK, Messagebox.INFORMATION);

                            closeWindow();
                        }

                    
                } else {
                    Messagebox.show(
                            Labels.getLabel("editarVigenciaTarifaController.MSG.conflitoVigencias"),
                            Labels.getLabel("editarVigenciaTarifaController.window.title"),
                            Messagebox.OK, Messagebox.EXCLAMATION);
                }
            } else {
                Messagebox.show(
                        Labels.getLabel("editarVigenciaTarifaController.MSG.FimMenorInicio"),
                        Labels.getLabel("editarVigenciaTarifaController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }

    public void onClick$btnApagar(Event ev) {
        vigenciaTarifa.setFecmodif(Calendar.getInstance().getTime());
        vigenciaTarifa.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        vigenciaTarifa.setActivo(Boolean.FALSE);

        try {
            int opcao = Messagebox.show(
                    Labels.getLabel("editarVigenciaTarifaController.btnFechar.MSG.Deseja.Borrar"),
                    Labels.getLabel("editarVigenciaTarifaController.window.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (opcao == Messagebox.YES) {

                //Não posso eliminar uma vigencia se existir tarifa!!!
                List<Tarifa> tarifa = tarifaService.buscarExisteVigencia(vigenciaTarifa);
                if (!tarifa.isEmpty()) {
                    Messagebox.show(
                            Labels.getLabel("editarVigenciaTarifaController.MSG.podeApagar"),
                            Labels.getLabel("editarVigenciaTarifaController.window.title"),
                            Messagebox.OK, Messagebox.EXCLAMATION);
                } else {
                    vigenciaTarifaService.borrar(vigenciaTarifa);
                    vigenciaList.removeItem(vigenciaTarifa);

                    Messagebox.show(
                            Labels.getLabel("editarVigenciaTarifaController.btnFechar.MSG.borrarOK"),
                            Labels.getLabel("editarVigenciaTarifaController.window.title"),
                            Messagebox.OK, Messagebox.INFORMATION);

                    closeWindow();
                }
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }
}
